<?php
namespace Fiscal\Logic\SimplesNacional;
use \Indeterminado\Entities\Mapaapuracsn;

class ValidacaoSN{

    // VERIFICA SE EXISTE ALGUM REGISTRO NA TABELA DE APURAÇÃO
    public static function validaMapaVazio($cdempresa, $nrorg){
        try{
            $repository = Mapaapuracsn::getRepository();
            $registroEncontrado = $repository->getUltimoMapa($cdempresa, $nrorg);
            return $registroEncontrado;

        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function getDataInicial($cdempresa, $nrorg){
        try {
            $repository = Mapaapuracsn::getRepository();
            $dataInicial = $repository->getDataInicial($cdempresa, $nrorg);
            return $dataInicial;

        }catch (\Exception $e) {
            throw $e;
        }
    }

    public static function getDataFinal($dataInicial, $cdempresa, $nrorg){
        try {
            $repository = Mapaapuracsn::getRepository();
            $dataFinal = $repository->getDataFinal($dataInicial, $cdempresa, $nrorg);
            return $dataFinal;

        }catch (\Exception $e) {
            throw $e;
        }
    }

    public static function getUltimoMapa($cdempresa, $nrorg){
        try{
            $repository = Mapaapuracsn::getRepository();
            $ultimoMapa = $repository->getUltimoMapa($cdempresa, $nrorg);

            if(tk_get_field_value('NRSEQUMAPAPU') === $ultimoMapa){
                return true;
            }else return false;

        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function getFaixaValores($cdsimplesnacional, $vrFaturamento){
        try {
            $repository = Mapaapuracsn::getRepository();
            $faixaValores = $repository->getFaixaValores($cdsimplesnacional, $vrFaturamento);
            return $faixaValores;

        }catch (\Exception $e){
            throw $e;
        }
    }

    public static function getCdsimplesNacionalVincEmpresa($cdsimplesnacional, $cdempresa, $nrorg){
        try {
            $repository = Mapaapuracsn::getRepository();
            $tabelaVinculada = $repository->getCdsimplesNacionalVincEmpresa($cdsimplesnacional, $cdempresa, $nrorg);
            return $tabelaVinculada;

        }catch (\Exception $e){
            throw $e;
        }
    }

    public static function getDataInicialNotaForaPeriodo(){
        try{
            $repository = Mapaapuracsn::getRepository();
            $dataInicial = $repository->getDataInicialNotaForaPeriodo();
            return $dataInicial;

        }catch (\Exception $e){
            throw $e;
        }
    }

    public static function getStatusMapaAnterior($cdempresa, $dtiniperiodo, $nrorg){
        try {
            $repository = Mapaapuracsn::getRepository();
            $statusMapaAnt = $repository->getStatusMapaAnterior($cdempresa, $dtiniperiodo, $nrorg);
            return $statusMapaAnt;

        }catch (\Exception $e){
            throw $e;
        }
    }

    public static function getStatusMapaPosterior($cdempresa, $dtfimperiodo, $nrorg){
        try {
            $repository = Mapaapuracsn::getRepository();
            $statusMapaAnt = $repository->getStatusMapaPosterior($cdempresa, $dtfimperiodo, $nrorg);
            return $statusMapaAnt;

        }catch (\Exception $e){
            throw $e;
        }
    }
}