<?php

require_once 'base/FpaCnabmagnetEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 * 
 * @package Entity
 * 
 * @author  thalesvalias
 */
class FpaCnabmagnetEntity extends FpaCnabmagnetEntityBase
{


    /**
     * Retorna registros.
     *
     * @param TkDateTime $mesCompetencia  Mes de Competencia.
     * @param string     $nrOrg           Numero da Organizacao.
     * @param string     $cdBanco         Codigo do Banco.
     * @param string     $nrTipoMovimento Numero do Tipo de Movimento.
     *
     * @return array FpacnabmagnetEntity
     *
     * @author thalesvalias - 26/07/2012
     */
    public function retornaRegistros(TkDateTime $mesCompetencia, $nrOrg, $cdBanco, $nrTipoMovimento){
        //tk_var_dump(func_get_args());
        return Fpacnabmagnet::retornaRegistros($mesCompetencia, $nrOrg, $cdBanco, $nrTipoMovimento);
    }


    /**
     * Cria lista de objetos FpacnabmagnetEntity conforme array de tipo de registros.
     *
     * @param string $mesCompetencia  Mes de Competencia.
     * @param string $tipoRegistro    Tipo de Registro.
     * @param string $nrOrg           Numero da Organizacao.
     * @param string $cdBanco         Codigo do Banco.
     * @param string $nrTipoMovimento Numero do Tipo de Movimento.
     *
     * @return boolean
     *
     * @author thalesvalias - 02/08/2012
     */
    public function inicializaListaRegistros($mesCompetencia, $tipoRegistro, $nrOrg, $cdBanco, $nrTipoMovimento){
            $resultados = Fpacnabmagnet::retornaRegistrosPorTipo($mesCompetencia, $tipoRegistro, $nrOrg, $cdBanco, $nrTipoMovimento);
        if (is_array($resultados) === true) {
            foreach ($resultados as $resultado) {
                $this->addItem($resultado, $resultado->getNrcnabmagnet());
            }

            return true;
        } else {
            return false;
        }
    }


    /**
     * Adiciona registro na lista.
     *
     * @param string  $nrOrg           Numero da Organizacao.
     * @param string  $mesCompetencia  Mes de competencia.
     * @param string  $tipoRegistro    Numero do tipo de registro.
     * @param string  $tipoInscricao   Numero do tipo de inscricao.
     * @param string  $nrInscricao     Numero da inscricao.
     * @param string  $linha           Linha do registro CNAB.
     * @param string  $cdBanco         Codigo do Banco.
     * @param string  $nrTipoMovimento Numero do Tipo de Movimento.
     * @param integer $sequencia       Numero sequencial representando um arquivo.
     *
     * @return void
     *
     * @author thalesvalias - 26/07/2012
     */
    public function insereRegistroLista(
        $nrOrg, $mesCompetencia, $tipoRegistro, $tipoInscricao, $nrInscricao, $linha, $cdBanco, $nrTipoMovimento, $nrSeqArquivo, $valor = null, $nrvinculom = null, $sequencia = null
    ){
        $item = new self();

        $item->setIdativo('S'); // Verificar.
        $item->setNrorg($nrOrg);
        $item->setMescompetencia($mesCompetencia);
        $item->setIdtiporegistro($tipoRegistro);
        $item->setIdtpinscestrutu($tipoInscricao);
        $item->setCdinscestrut($nrInscricao);
        $item->setDslinharegistro($linha);
        $item->setCdbanco($cdBanco);
        $item->setNrtipomoviment($nrTipoMovimento);
        $item->setNrvinculom($nrvinculom);
        $item->setValor($valor);
        $item->setNrsequencialarquivo($sequencia);
        $item->setNrsequencialarquivo($nrSeqArquivo);

        $this->addItem($item);

    }


    /**
     * Insere ou atualiza registro.
     *
     * @param string $nrOrg                Numero da organizacao.
     * @param string $mesCompetencia       Mes de competencia.
     * @param string $tipoRegistro         Tipo de registro CNAB.
     * @param string $tipoInscricao        Tipo de inscricao.
     * @param string $nrInscricao          Numero de inscricao.
     * @param string $linha                Linha do registro.
     * @param string $nrVinculoM           Numero do vinculo.
     * @param string $segmento             Numero do segmento do registro.
     * @param string $cdBanco              Codigo do Banco.
     * @param string $nrTipoMovimento      Numero do Tipo de Movimento.
     * @param float  $valor                Valor do pagamento.
     * @param string $tipoInscricaoVinculo Tipo de inscricao do Vinculo.
     * @param string $nrInscricaoVinculo   Numero de inscricao do Vinculo.
     *
     * @return void
     *
     * @author thalesvalias - 26/07/2012
     */
    public function persisteRegistro(
        $nrOrg, $mesCompetencia, $tipoRegistro, $segmento, $tipoInscricao, $nrInscricao,
        $linha, $nrVinculoM, $cdBanco, $nrTipoMovimento, $valor, $tipoInscricaoVinculo, $nrInscricaoVinculo
    ){
        // Procura o registro na base.
        $item = Fpacnabmagnet::retornaRegistro(
            $mesCompetencia, $nrOrg, $tipoRegistro, $segmento, $tipoInscricao, $nrInscricao, $nrVinculoM, $cdBanco, $nrTipoMovimento
        );

        if (is_object($item) === true) {
            $item->setNrcnabmagnet($item->getNrcnabmagnet());
            $item->setDslinharegistro($linha);
        } else {
            $item = new self();

            $item->setIdativo('S'); // Verificar.
            $item->setNrorg($nrOrg);
            $item->setMescompetencia($mesCompetencia);
            $item->setIdtiporegistro($tipoRegistro);
            $item->setIdtpinscestrutu($tipoInscricao);
            $item->setCdinscestrut($nrInscricao);
            $item->setNrvinculom($nrVinculoM);
            $item->setDslinharegistro($linha);
            $item->setIdsegmento($segmento);
            $item->setCdbanco($cdBanco);
            $item->setNrtipomoviment($nrTipoMovimento);
            $item->setValor($valor);
            $item->setIdtpinscvinculo($tipoInscricaoVinculo);
            $item->setCdinscvinculo($nrInscricaoVinculo);
        }

        $item->persist();
    }


    /**
     * Procura registro na lista.
     *
     * @param string $nrInscricao     Numero da inscricao da empresa.
     * @param string $tpRegistro      Numero do tipo do registro.
     * @param string $cdBanco         Numero do tipo do registro.
     * @param string $nrTipoMovimento Numero do Tipo de Movimento.
     *
     * @return boolean
     *
     * @author thalesvalias - 27/06/2012
     */
    public function procuraRegistroLista($nrInscricao, $tpRegistro, $cdBanco, $nrTipoMovimento) {
        $itens = $this->getItems();
        foreach ($itens as $key => $item) {
            if (($item->getCdinscestrut() === (string)$nrInscricao)
                && ($item->getIdtiporegistro() === (string)$tpRegistro)
                && ($item->getCdbanco() === (string)$cdBanco)
                && ($item->getNrtipomoviment() === (string)$nrTipoMovimento)
            ) {
                return $key;
            }
        }

        return false;
    }


    /**
     * Remove todos os registros da Org. no mes de competencia.
     *
     * @param integer $nrOrg           Numero da Organizacao.
     * @param string  $mesCompetencia  Mes de competencia.
     * @param string  $cdBanco         Codigo do Banco.
     * @param string  $nrTipoMovimento Numero do Tipo de Movimento.
     *
     * @return void
     *
     * @author thalesvalias - 27/06/2012
     */
    public function retroceder($nrOrg, $mesCompetencia, $cdBanco, $nrTipoMovimento){

        $registros = $this->retornaRegistros($mesCompetencia, $nrOrg, $cdBanco, $nrTipoMovimento);
        if (count($registros) > 0) {
            foreach ($registros as $registro) {
                $this->addItem($registro);
                $this->removeItem($registro);
            }

            $this->persist();
        }
    }


    /**
     * Retorna o total de registros de acordo com o tipo de registro informado.
     *
     * @param string  $mesCompetencia Mes de Competencia.
     * @param integer $nrOrg          Numero da Organizacao.
     * @param string  $tiposRegistro  Tipos de Registros.
     * @param string  $cdBanco        Codigo do Banco.
     * @param string  $nrTipoMovimento Numero do Tipo de Movimento.
     *
     * @return number
     *
     * @author thalesvalias 07/08/2012
     */
    public function totalRegistrosPorTipos($mesCompetencia, $nrOrg, $tiposRegistro, $cdBanco, $nrTipoMovimento){
        $totalRegistros = FpaCnabmagnet::totalRegistrosPorTipos($mesCompetencia, $nrOrg, $tiposRegistro, $cdBanco, $nrTipoMovimento);

        if (empty($totalRegistros) === false){
            $totalRegistros = end(end($totalRegistros));
        }

        return $totalRegistros;
    }


    /**
     * Retorna o ultimo(maior) numero sequencial do registro 0 de acordo com a competencia e o codigo do banco informados.
     *
     * @param string  $mesCompetencia Mes de Competencia.
     * @param integer $nrOrg          Numero da Organizacao.
     * @param string  $cdBanco        Codigo do Banco.
     *
     * @return number
     *
     * @author thalesvalias 10/08/2012
     */
    public function retornaUltimoSequencialRegistro0($mesCompetencia, $nrOrg, $cdBanco){
        $ultimoSequencial = FpaCnabmagnet::retornaUltimoSequencialRegistro0($mesCompetencia, $nrOrg, $cdBanco);

        if (empty($ultimoSequencial) === false){
            $ultimoSequencial = end(end($ultimoSequencial));
        }

        return $ultimoSequencial;
    }


    /**
     * Modifica a sequencia dos registros 0 que pertencem ao mesmo envio.
     * Mesmo envio = mesma competencia e mesmo banco. Cada 0 representa um novo arquivo.
     *
     * @param string  $mesCompetencia  Mes de Competencia.
     * @param integer $nrOrg           Numero da Organizacao.
     * @param string  $cdBanco         Codigo do Banco.
     *
     * @return void
     *
     * @author thalesvalias 10/08/2012
     */
    public function modificaSequenciaArquivoRemessa($mesCompetencia, $nrOrg, $cdBanco){

        $arquivosRemessa = FpaCnabmagnet::retornaRegistros0Remessa($mesCompetencia, $nrOrg, $cdBanco);

        if (empty($arquivosRemessa) === false) {

            $contador = 1;
            foreach($arquivosRemessa as $arquivo) {

                $arquivo->setNrsequencialarquivo($contador);
                $arquivo->persist();

                $contador++;
            }
        }
    }


    /**
     * Retorna registros filtrados por vinculo para um segmento.
     *
     * @param integer    $nrOrg          Numero da Organizacao
     * @param TkDateTime $mesCompetencia Mes de Competencia
     * @param integer    $nrVinculom     Numero do Vinculo
     * @param string     $idSegmento     Identificador do segmento
     *
     * @return FpaCnabmagnetEntity | null
     *
     * @author alessandrobartels - 03/10/2012
     */
    public function retornaRegistroPorVinculoSegmento($nrOrg, $mesCompetencia, $nrVinculom, $idSegmento){
        $resultado = FpaCnabmagnet::retornaRegistroPorVinculoSegmento($nrOrg, $mesCompetencia, $nrVinculom, $idSegmento);
        return $resultado;
    }
}