<?php

require_once 'base/FpadepvinculoEntityBase.php';


/**
 * Enter description here ...
 *
 * @package Entity
 *
 * @author  alessandrobartels
 *
 */
class FpadepvinculoEntity extends FpaDepvinculoEntityBase
{

    private $_nrOrg;
    private $_nrOrgPadrao;


    public function __construct($id = null, $nrOrg = null, $nrOrgPadrao = null){
        parent::__construct($id);
        $this->_nrOrg = $nrOrg;
        $this->_nrOrgPadrao = $nrOrgPadrao;
    }


    /**
     * Enter description here ...
     *
     * @param integer $nr_vinculo Numero do Vinculo.
     *
     * @return void
     */
    public function carregaDependenciasPorVinculo($nr_vinculo) {
        $this->resetItems();
        $dependencias = Fpadepvinculo::retornaDependenciasPorVinculo($nr_vinculo, $this->_nrOrg);
        foreach ($dependencias as $dependencia){
            $this->addItem($dependencia);
        }
        
    }


    /**
     * Verifica numero de dependentes por vinculo.
     *
     * @param GpevinculomEntity    $vinculo          Vinculo.
     * @param GpepessoaEntity      $pessoa           Pessoa.
     * @param FpatipodependeEntity $tipo_dependencia Tipo de Dependencia.
     *
     *  @return void
     */
    /* public function verificaDependentesVinculo(
        GpevinculomEntity $vinculo, GpepessoaEntity $pessoa, FpatipodependeEntity $tipo_dependencia
    ) {
        $dependencias = $this->retornaDependenciasPorVinculo($vinculo->getNrvinculom());
        if (empty($dependencias) === false) {
            $nr_dependentes = 0;
            foreach ($dependencias as $key => $dependencia) {
                if ($key !== 0) {
                    if ($dependencia->getNrtipodepende() !== $obj_tipo_dependencia->getNrtipodepende()) {
                        $this->_atualizaDependentesVinculo($vinculo, $obj_tipo_dependencia, $nr_dependentes);
                        $nr_dependentes = 0;
                    }
                }

                $data_dependente = new TkDateTime();
                $obj_pessoa = $pessoa->retornaPessoaPorParceiro(
                    $dependencia->getNrorg(), $dependencia->getNrpessoa()
                );
                $obj_tipo_dependencia = $tipo_dependencia->retornaTipoDependencia(
                    $this->_nrOrg, $this->_nrOrgPadrao, $dependencia->getNrtipodepende()
                );

                $sexo_dependente = $obj_pessoa->historico->getIdsexopessoa();
                $data_dependente->subDate($obj_pessoa->historico->getDtnascpessoa());
                $idade_dependente = $data_dependente->toValue(TkDateTime::YEAR);

                /* @todo Testar a escolaridade do dependente. */
      /*          switch ($sexo_dependente) {
                case GpepessoahEntity::IDSEXOPESSOA_MASCULINO:
                    if ($idade_dependente <= $obj_tipo_dependencia->getNridadelimhonun()) {
                          $nr_dependentes++;
                    }

                    /*
                     * if ($idade_dependente <= $obj_tipo_dependencia->getNridadelimhouni()) {
                     *     $nr_dependente++;
                     * }
                     */
            /*        break;
                case GpepessoahEntity::IDSEXOPESSOA_FEMININO:
                    if ($idade_dependente <= $obj_tipo_dependencia->getNridadelimmunun()) {
                          $nr_dependentes++;
                    }

                    /*
                     * if ($idade_dependente <= $obj_tipo_dependencia->getNridadelimmuuni()) {
                     * 	   $nr_dependente++;
                     * }
                     */
              /*      break;
                }
            }

            $this->_atualizaDependentesVinculo($vinculo, $obj_tipo_dependencia, $nr_dependentes);
            $vinculo->historico->adicionaPersisteHistorico();
        }
    }*/


    /**
     * Atualiza atributos do vinculo (dependentes de salario familia e imposto de renda).
     *
     * @param GpevinculomEntity    $vinculo              Vinculo.
     * @param FpatipodependeEntity $obj_tipo_dependencia Tipo de Dependencia.
     * @param integer              $nr_dependentes       Numero de Dependentes.
     *
     * @return void
     */
    private function _atualizaDependentesVinculo(
        GpevinculomEntity $vinculo, FpatipodependeEntity $obj_tipo_dependencia, $nr_dependentes
    ) {
        if ($obj_tipo_dependencia->getIdatudepsalfam() === FpatipodependeEntity::IDATUDEPSALFAM_SIM) {
            $vinculo->historico->atualizaNrDependentesSalarioFamilia($nr_dependentes);
        }

        if ($obj_tipo_dependencia->getIdatudepirrf() === FpatipodependeEntity::IDATUDEPIRRF_SIM) {
            $vinculo->historico->atualizaNrDependentesImpostoRenda($nr_dependentes);
        }
    }

    public function insereDependenteVinculo($nrorg, $nrpessoa, $nrtipodepende, $nrfuncvinculom) {
        $this->setNrorg($nrorg);
        $this->setNrpessoa($nrpessoa);
        $this->setNrtipodepende($nrtipodepende);
        $this->setNrvinculom($nrfuncvinculom);
    }

}

