package com.javaseleniumtemplate.tests.naocontrolaalmoxarifado;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.dbsteps.DBSteps;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.naocontrolaalmoxarifado.RetiradaDeEstoqueNaoControlaAlmoxarifadoFlows;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.naocontrolaalmoxarifado.RetiradaDeEstoqueNaoControlaAlmoxarifadoPage;
import org.testng.Assert;
import org.testng.annotations.Ignore;
import org.testng.annotations.Test;

public class RetiradaDeEstoqueNaoControlaAlmoxarifadoTests extends TestBase{
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    RetiradaDeEstoqueNaoControlaAlmoxarifadoFlows retiradaDeEstoqueNaoControlaAlmoxarifadoFlows;
    RetiradaDeEstoqueNaoControlaAlmoxarifadoPage retiradaDeEstoqueNaoControlaAlmoxarifadoPage;


    @Test (description = "Est-40")
    @Ignore
    public void EfetuarRetiradaDeEstoque(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        retiradaDeEstoqueNaoControlaAlmoxarifadoFlows = new RetiradaDeEstoqueNaoControlaAlmoxarifadoFlows();
        retiradaDeEstoqueNaoControlaAlmoxarifadoPage = new RetiradaDeEstoqueNaoControlaAlmoxarifadoPage();


        //Parameteres_Lançamento:
        String quantidade = "3";
        String cmpDesc = "Teste Automatizado Retirada de Estoque";
        String descProduto = "SUMO DE LIMAO - CX12 500ML";
        String descAlmoxarifado = "HELA MATRIZ";
        String campoSetor = "Administrativo";
        String DescCampoLote = "025/50";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String valorDevolvido = "1";
        String campoRetirada = "CONSUMO DE PRODUÇÃO";
        String quantidadeBanco = "18";
        String quantidadeSolicitada = "3";
        String quantidadeDevolvida = "1";
        String quantidadeRestante = "2";
        String valorUnitarioLancado = "1.2";






        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTrocaUnidadeNaoControlaAlmoxarifado();
        mainFlows.AcessandoRetiradaDeEstoque();
        retiradaDeEstoqueNaoControlaAlmoxarifadoFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
        retiradaDeEstoqueNaoControlaAlmoxarifadoFlows.AdicionarRetiradaEstoque(cmpDesc,descProduto,quantidade,descAlmoxarifado,DescCampoLote,valorDevolvido, campoSetor, campoRetirada);


        //Banco tela de retirada
       String numeroLancamento = retiradaDeEstoqueNaoControlaAlmoxarifadoPage.retornaNumeroLancamento();
       Assert.assertTrue(DBSteps.retornaQuatidadeEstoque(numeroLancamento).contains(quantidadeBanco));

        String valorSolicitado = retiradaDeEstoqueNaoControlaAlmoxarifadoPage.retornaQuantidadeSolicitada();
        Assert.assertTrue(DBSteps.retornaQuantidadeSolicitadaEstoque(valorSolicitado).contains(quantidadeSolicitada));

        String devolucaoEstoque = retiradaDeEstoqueNaoControlaAlmoxarifadoPage.retornaQuantidadeDevolvida();
         Assert.assertTrue(DBSteps.retornaQuantidadeDevolvidaEstoque(devolucaoEstoque).contains(quantidadeDevolvida));

       String restanteEstoque = retiradaDeEstoqueNaoControlaAlmoxarifadoPage.retornaQuantidadeRestante();
        Assert.assertTrue(DBSteps.retornaQuantidadeRestanteEstoque(restanteEstoque).contains(quantidadeRestante));

        Assert.assertTrue(DBSteps.retornaValorUnitarioLancadoEstoque(numeroLancamento).contains(valorUnitarioLancado));




    }
    @Test(description = "Est-41")
    @Ignore
    public void EditarRetiradaEstoque(){
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        retiradaDeEstoqueNaoControlaAlmoxarifadoFlows = new RetiradaDeEstoqueNaoControlaAlmoxarifadoFlows();
        retiradaDeEstoqueNaoControlaAlmoxarifadoPage = new RetiradaDeEstoqueNaoControlaAlmoxarifadoPage();

        //Parametres
        String descAlmoxarifado = "HELA MATRIZ";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String campoEditado ="Deletar";

        //Rotine:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTrocaUnidadeNaoControlaAlmoxarifado();
        mainFlows.AcessandoRetiradaDeEstoque();
        retiradaDeEstoqueNaoControlaAlmoxarifadoFlows.aplicarFiltro(descUnidade, descAlmoxarifado);
        retiradaDeEstoqueNaoControlaAlmoxarifadoFlows.EditarRetiradaEstoque(campoEditado);

    }
    @Test(description = "Est-42")
    @Ignore
    public void ExcluirRetiradaEstoque(){
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        retiradaDeEstoqueNaoControlaAlmoxarifadoFlows = new RetiradaDeEstoqueNaoControlaAlmoxarifadoFlows();
        retiradaDeEstoqueNaoControlaAlmoxarifadoPage = new RetiradaDeEstoqueNaoControlaAlmoxarifadoPage();

        //Parametres
        String descAlmoxarifado = "HELA MATRIZ";
        String descUnidade = "HELA INGREDIENTES BRASIL";


        //rotine
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTrocaUnidadeNaoControlaAlmoxarifado();
        mainFlows.AcessandoRetiradaDeEstoque();
        retiradaDeEstoqueNaoControlaAlmoxarifadoFlows.aplicarFiltro(descUnidade, descAlmoxarifado);
        retiradaDeEstoqueNaoControlaAlmoxarifadoFlows.ExcluirRetiradaEstoque();


    }

@Test(description = "Est-00")
@Ignore
    public void TesteBanco() {

    mainPage = new MainPage();
    loginFlows = new LoginFlows();
    mainFlows = new MainFlows();
    retiradaDeEstoqueNaoControlaAlmoxarifadoFlows = new RetiradaDeEstoqueNaoControlaAlmoxarifadoFlows();
    retiradaDeEstoqueNaoControlaAlmoxarifadoPage = new RetiradaDeEstoqueNaoControlaAlmoxarifadoPage();


    //Rotinas:
    // loginFlows.efetuarLogin();
    String ntlancestq = "0000007209";
    String teste = DBSteps.retornaQuantidadeRestanteEstoque(ntlancestq);
    System.out.println(teste);


}
}